OcsdTraceElement Class Reference
OpenCSD Library : Generic Trace Elements

Generic trace element class. More...

`#include <trc_gen_elem.h>`

Inheritance diagram for OcsdTraceElement:
[legend]
Collaboration diagram for OcsdTraceElement:
[legend]

## Public Member Functions

| OcsdTraceElement ()
| OcsdTraceElement (ocsd_gen_trc_elem_t type)
virtual | ~OcsdTraceElement ()
void | init ()
void | setType (const ocsd_gen_trc_elem_t type)
| set type and init flags More...
void | updateType (const ocsd_gen_trc_elem_t type)
| change type only - no init More...
void | setContext (const ocsd_pe_context &new_context)
void | setISA (const ocsd_isa isa_update)
void | setCycleCount (const uint32_t cycleCount)
void | setEvent (const event_t ev_type, const uint16_t number)
void | setTS (const uint64_t ts, const bool freqChange=false)
void | setExcepMarker ()
void | setExceptionNum (uint32_t excepNum)
void | setTraceOnReason (const trace_on_reason_t reason)
void | setAddrRange (const ocsd_vaddr_t st_addr, const ocsd_vaddr_t en_addr, const int num_instr=1)
void | setLastInstrInfo (const bool exec, const ocsd_instr_type last_i_type, const ocsd_instr_subtype last_i_subtype, const uint8_t size)
void | setAddrStart (const ocsd_vaddr_t st_addr)
void | setLastInstrCond (const int is_cond)
void | setSWTInfo (const ocsd_swt_info_t swt_info)
void | setExtendedDataPtr (const void *data_ptr)
virtual void | toString (std::string &str) const
OcsdTraceElement & | operator= (const ocsd_generic_trace_elem *p_elem)
const ocsd_gen_trc_elem_t | getType () const
const ocsd_pe_context & | getContext () const
Public Member Functions inherited from trcPrintableElem
| trcPrintableElem ()
virtual | ~trcPrintableElem ()
virtual void | toStringFmt (const uint32_t fmtFlags, std::string &str) const

## Additional Inherited Members

Static Public Member Functions inherited from trcPrintableElem
static void | getValStr (std::string &valStr, const int valTotalBitSize, const int valValidBits, const uint64_t value, const bool asHex=true, const int updateBits=0)
Public Attributes inherited from _ocsd_generic_trace_elem
ocsd_gen_trc_elem_t | elem_type
ocsd_isa | isa
ocsd_vaddr_t | st_addr
ocsd_vaddr_t | en_addr
ocsd_pe_context | context
uint64_t | timestamp
uint32_t | cycle_count
ocsd_instr_type | last_i_type
ocsd_instr_subtype | last_i_subtype
union {
struct {
uint32_t last_instr_exec:1
uint32_t last_instr_sz:3
uint32_t has_cc:1
uint32_t cpu_freq_change:1
uint32_t excep_ret_addr:1
uint32_t excep_data_marker:1
uint32_t extended_data:1
uint32_t has_ts:1
uint32_t last_instr_cond:1
uint32_t excep_ret_addr_br_tgt:1
} |
uint32_t flag_bits
}; |
| per element flags More...
union {
uint32_t exception_number
trace_event_t trace_event
trace_on_reason_t trace_on_reason
ocsd_swt_info_t sw_trace_info
uint32_t num_instr_range
}; |
| packet specific payloads More...
const void * | ptr_extended_data

## Detailed Description

Generic trace element class.

Definition at line 49 of file trc_gen_elem.h.

## Constructor & Destructor Documentation

## ~OcsdTraceElement()

virtual OcsdTraceElement::~OcsdTraceElement | ( |  | ) |

inline virtual

Definition at line 54 of file trc_gen_elem.h.

## Member Function Documentation

## getContext()

const ocsd_pe_context& OcsdTraceElement::getContext | ( |  | ) | const

inline

Definition at line 95 of file trc_gen_elem.h.

## getType()

const ocsd_gen_trc_elem_t OcsdTraceElement::getType | ( |  | ) | const

inline

Definition at line 92 of file trc_gen_elem.h.

## operator=()

OcsdTraceElement& OcsdTraceElement::operator= | ( | const ocsd_generic_trace_elem * | p_elem | ) |

## setAddrStart()

void OcsdTraceElement::setAddrStart | ( | const ocsd_vaddr_t | st_addr | ) |

inline

Definition at line 78 of file trc_gen_elem.h.

## setContext()

void OcsdTraceElement::setContext | ( | const ocsd_pe_context & | new_context | ) |

inline

Definition at line 63 of file trc_gen_elem.h.

## setExcepMarker()

void OcsdTraceElement::setExcepMarker | ( |  | ) |

inline

Definition at line 70 of file trc_gen_elem.h.

## setExceptionNum()

void OcsdTraceElement::setExceptionNum | ( | uint32_t | excepNum | ) |

inline

Definition at line 71 of file trc_gen_elem.h.

## setLastInstrCond()

void OcsdTraceElement::setLastInstrCond | ( | const int | is_cond | ) |

inline

Definition at line 79 of file trc_gen_elem.h.

## setSWTInfo()

void OcsdTraceElement::setSWTInfo | ( | const ocsd_swt_info_t | swt_info | ) |

inline

Definition at line 81 of file trc_gen_elem.h.

## toString()

virtual void OcsdTraceElement::toString | ( | std::string & | str | ) | const

virtual

Reimplemented from trcPrintableElem.

The documentation for this class was generated from the following file:

- /build/libopencsd-WqHKQU/libopencsd-0.12.2/decoder/include/common/trc_gen_elem.h